

#ifndef BAUD1
#  error "setbaud.h requires BAUD1 to be defined"
#endif



/* Baud rate tolerance is 2 % unless previously defined */
#ifndef BAUD_TOL
#  define BAUD_TOL 2
#endif

#define UBRR_VALUE1 (((F_CPU) + 8UL * (BAUD1)) / (16UL * (BAUD1)) -1UL)

#if 100 * (F_CPU) > \
  (16 * ((UBRR_VALUE1) + 1)) * (100 * (BAUD1) + (BAUD1) * (BAUD_TOL))
#  define USE1_2X 1
#elif 100 * (F_CPU) < \
  (16 * ((UBRR_VALUE1) + 1)) * (100 * (BAUD1) - (BAUD1) * (BAUD_TOL))
#  define USE1_2X 1
#else
#  define USE1_2X 0
#endif

#if USE1_2X
/* U2X required, recalculate */
#undef UBRR_VALUE1
#define UBRR_VALUE1 (((F_CPU) + 4UL * (BAUD1)) / (8UL * (BAUD1)) -1UL)

#if 100 * (F_CPU) > \
  (8 * ((UBRR_VALUE1) + 1)) * (100 * (BAUD1) + (BAUD1) * (BAUD_TOL))
#  warning "Baud rate achieved is higher than allowed"
#endif

#if 100 * (F_CPU) < \
  (8 * ((UBRR_VALUE1) + 1)) * (100 * (BAUD1) - (BAUD1) * (BAUD_TOL))
#  warning "Baud rate achieved is lower than allowed"
#endif

#endif /* USE_U2X */

#ifdef UBRR_VALUE1
#  define UBRRL_VALUE1 (UBRR_VALUE1 & 0xff)
#  define UBRRH_VALUE1 (UBRR_VALUE1 >> 8)
#endif
